#!/bin/sh

## live-build(7) - System Build Scripts
## Copyright (C) 2006-2011 Daniel Baumann <daniel@debian.org>
##
## live-build comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
## This is free software, and you are welcome to redistribute it
## under certain conditions; see COPYING for details.


set -e

# Including common functions
. "${LB_BASE:-/usr/share/live/build}"/scripts/build.sh

# Setting static variables
DESCRIPTION="$(Echo 'execute hooks in chroot')"
HELP=""
USAGE="${PROGRAM} [--force]"

Arguments "${@}"

# Reading configuration files
Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
Set_defaults

Echo_message "Begin executing hooks..."

# Requiring stage file
Require_stagefile .stage/config .stage/bootstrap

# Checking stage file
Check_stagefile .stage/chroot_hooks

# Checking lock file
Check_lockfile .lock

# Creating lock file
Create_lockfile .lock

## Processing distribution hooks

# Copying hooks
for _HOOK in ${LB_CHROOT_HOOKS}
do
	if [ -e "${LB_BASE}/hooks/???-${_HOOK}.chroot" ]
	then
		mkdir -p chroot/root/lb_chroot_hooks
		cp "${LB_BASE}/hooks/???-${_HOOK}.chroot" chroot/root/lb_chroot_hooks
	fi
done

# Running hooks
if ls chroot/root/lb_chroot_hooks/* > /dev/null 2>&1
then
	for _HOOK in chroot/root/lb_chroot_hooks/*
	do
		Chroot chroot "/root/$(basename ${_HOOK})" || { Echo_error "${_HOOK} failed (exit non-zero). You should check for errors."; exit 1 ;}
		rm -f chroot/root/"$(basename ${_HOOK})"
	done

	rmdir chroot/root/lb_chroot_hooks
fi

## Processing local hooks

if Find_files config/hooks/*.chroot
then
	# Restoring cache
	Restore_cache cache/packages_chroot

	# Make build config available to chroot hooks.
	mkdir -p chroot/root/config
	mount -o bind,ro config chroot/root/config

	for _HOOK in config/hooks/*.chroot
	do
		# Copying hook
		cp "${_HOOK}" chroot/root

		# Making hook executable
		if [ ! -x chroot/root/"$(basename ${_HOOK})" ]
		then
			chmod +x chroot/root/"$(basename ${_HOOK})"
		fi

		# Executing hook
		Chroot chroot "/root/$(basename ${_HOOK})" || { Echo_error "${_HOOK} failed (exit non-zero). You should check for errors."; exit 1 ;}

		# Removing hook
		rm -f chroot/root/"$(basename ${_HOOK})"
	done

	# Remove bind mount of build config inside chroot.
	umount chroot/root/config
	rmdir chroot/root/config

	# Saving cache
	Save_cache cache/packages_chroot

	# Creating stage file
	Create_stagefile .stage/chroot_hooks
fi
